import { HttpParams } from '@angular/common/http';
import { Component, OnInit } from '@angular/core';
import { FormBuilder, FormGroup, Validators } from '@angular/forms';
import *  as Highcharts from "highcharts/highmaps";
import { MapChart } from 'highcharts/highmaps';
import proj4 from 'proj4';
import { TopNPowerPlantsService } from 'src/app/service/topn.powerplants.service';
import usAllData from '../../../assets/us-map/us-all.topo.json';

@Component({
  selector: 'app-top-n-powerplants',
  templateUrl: './top-n-powerplants.component.html',
  styleUrls: ['./top-n-powerplants.component.css']
})
export class TopNPowerplantsComponent implements OnInit {

  Highcharts: typeof Highcharts = Highcharts;
  mapHighcharts: typeof Highcharts = Highcharts;
  chartConstructor = "chart";
  mapChartConstructor = "mapChart";
  chartOptions!: Highcharts.Options;
  mapOptions!: Highcharts.Options;
  searchForm: FormGroup;
  mapChart!: MapChart;

  constructor(private formBuilder: FormBuilder, private topNPowerPlantsService: TopNPowerPlantsService) {
    this.searchForm = this.formBuilder.group({
      topN: ['5', [
        Validators.required, // Validators
        Validators.min(1),
        Validators.max(5000)
      ]],
    });

    Highcharts.setOptions({ lang: { thousandsSep: ','} });
    this.buildMapOption([]);

  }

  ngOnInit(): void {
    this.loadData();
  }


  /**
   * This method is used to build the chart option
   * @param data    - chart data
   */
  private buildChartOption(data: any) {
    const chartOptions: Highcharts.Options = {
      chart: {
        zoomType: 'xy',
        marginBottom: 100,
        borderWidth: 2,
      },
      title: {
        text: "Top Power Plants in US"
      },
      subtitle: {
        text: `<b>Visualize Top Net Power Generated by Power Plants in Chart</b>`
      },
      xAxis: [{
        categories: data.categories,
        crosshair: true,
        title: {
          text: '<b>PowerPlant Name</b>',
          style: {
            color: 'black'
          }
        }
      }],
      yAxis: [{ // Primary yAxis
        labels: {
          format: '{value}%',
          style: {
            color: 'blue'
          }
        },
        title: {
          text: '<b>Percentage</b>',
          style: {
            color: 'blue'
          }
        }
      }, { // Secondary yAxis
        title: {
          text: '<b>Total Net Power Generated</b>',
          style: {
            color: 'black'
          }
        },
        labels: {
          format: '{value} MWh',
          style: {
            color: 'black'
          }
        },
        opposite: true
      }],
      tooltip: {
        shared: true
      },
      legend: {
        align: 'center',
        verticalAlign: 'bottom',
        layout: 'horizontal',
        x: 0,
        y: 0,
        floating: true,
        backgroundColor: Highcharts.defaultOptions?.legend?.backgroundColor || 'rgba(255,255,255,0.25)'
      },
      series: [{
        name: 'Total Net Power Generated',
        type: 'column',
        yAxis: 1,
        data: data.totalPowerGeneratedSeries,
        tooltip: {
          valueSuffix: ' MWh'
        },

      }, {
        name: 'Percentage',
        type: 'column',
        data: data.percentageSeries,
        tooltip: {
          valueSuffix: '%'
        }
      }]
    };
    return chartOptions;
  }


  /**
   * This method is used to build the chart option
   * @param data    - map data
   */
  private buildMapOption(data: any) {
    this.mapOptions = {
      chart: {
        animation: false,
        borderWidth: 2,
      },
      title: {
        text: "Top Power Plants in US"
      },
      subtitle: {
        text: `<b>Visualize Top Net Power Generated by Power Plants in US Map</b>`
      },
      mapView: usAllData.objects.default['hc-recommended-mapview'],
      tooltip: {
        pointFormatter: function () {
          // @ts-ignore
          const totalPower: number = this.totalPower;
          const totalPowerStr: string = totalPower.toLocaleString('en-US', { maximumFractionDigits: 3 });
          const percentage = this.percentage;
          return `<b>PlantName: ${this.name}</b></br><b>Total Net Power Generated: ${totalPowerStr} Mwh</b></br><b>Percentage: ${percentage}%</b>`;
        }
        
      },
      series: [{
          name: 'Basemap',
          mapData: Highcharts.geojson(usAllData),
          borderColor: '#606060',
          nullColor: 'rgba(200, 200, 200, 0.2)',
          showInLegend: false,
          type: "map",
          dataLabels: {
            enabled: true,
            format: '{point.properties.postal-code}'
          },
      }, {
          type: 'mapbubble',
          dataLabels: {
              enabled: true,
              format: '{point.capital}'
          },
          name: 'Power Plants',
          data: data,
          maxSize: '12%',
          color: '#7cb5ec'
      }]
    };
  }


  /**
   * This method is used to load the chart data
   */
  loadData() {
    const params: HttpParams = new HttpParams().set('limit', this.searchForm.controls['topN'].value);
    this.topNPowerPlantsService.getTopNPowerPlants(params).subscribe((response) => {

      // build chart data
      const chartData = {
        categories: response.map((data: any) => data.name),
        totalPowerGeneratedSeries:  response.map((data: any) => data.totalPower),
        percentageSeries: response.map((data: any) => data.percentage)
      };
      this.chartOptions = this.buildChartOption(chartData);

      // build map data
      const powerplantMapData = this.buildPowerPlantData(response);
      this.buildMapOption(powerplantMapData);
    });
  }

  /**
   * This method is used to build the power plant data
   * @param powerplantData    - power plant dat
   */
  private buildPowerPlantData(powerplantData: any) {
    return powerplantData.map((powerPlant: any) => {
      return {
        name: powerPlant.name,
        lon: powerPlant?.location.coordinates[0],
        lat: powerPlant?.location.coordinates[1],
        z: powerPlant.percentage,
        percentage: powerPlant.percentage,
        totalPower: powerPlant.totalPower
      };
    });
  }

  /**
   * This method is used to handle search button
   */
  onSubmit() {
    this.loadData();
  }

}
